﻿using System;
using System.Linq;
using System.Management;

namespace ControllerForcePower
{
    /// <summary>
    /// Configure ForcePower settings through WMI (Namespace: "\root\WMI" Base Class: "MTBT_ForcePower")
    /// </summary>
    internal class Program
    {

        private static void Main(string[] args)
        {
            if (args.Length < 1 || (args[0] != "1" && args[0] != "0"))
            {
                Console.WriteLine("Set 1 to set force power and 0 to unset it");
                return;
            }

            try
            {
                //Selects Force Power WMI interface
                var searcher = new ManagementObjectSearcher("root\\WMI", "SELECT * FROM MTBT_ForcePower");

                foreach (var queryObj in searcher.Get().Cast<ManagementObject>())
                {
                    // Create the values for the in-parameters
                    ManagementBaseObject inParams = queryObj.GetMethodParameters("SetForcePower");
                    inParams["Data"] = int.Parse(args[0]);

                    // Execute Method
                    queryObj.InvokeMethod("SetForcePower", inParams, null);
                }

            }
            
            catch (Exception err)
            {
                Console.WriteLine("An error occurred while trying to execute the WMI method: " + err.Message);
            }
        }
    }

}
